close all
original=imread('penguin-orig.png');


original=double(original);

[nx ny]=size(original);
noise=20*randn(nx,ny);
corrupted=uint8(original+noise);
corrupted=double(corrupted);


beta2=10^2;
alpha2=3^2;

threshold=10^2/alpha2;

intensityarray=0:255;
newimage=corrupted;
solutionimage=corrupted;
iterNo=125;

figure(34846)
subplot(1,3,1)
imshow(uint8(original))
subplot(1,3,2)
imshow(uint8(corrupted))
subplot(1,3,3)
imshow(uint8(corrupted))
title(['Iter No: ', num2str(0)])
pause
for iter=1:iterNo,
    newimage=solutionimage;
    %Main loop forward
    for i=1:nx,
        for j=1:ny,
            cost=zeros(1,256);
            cost=(intensityarray-corrupted(i,j)).^2/(beta2);            
            if i==1,
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
            elseif i==nx
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            end
            if j==1,
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);
            elseif j==ny
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);                
            end
            if (i~=1)&&(i~=nx)&&(j~=1)&&(j~=ny)
                cost=cost+min((intensityarray-newimage(i+1,j+1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i+1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j+1)).^2/alpha2,threshold);
            end
            [minval minind]=min(cost); 
            solutionimage(i,j)=intensityarray(minind);
        end
    end
    newimage=solutionimage;
    %An optional backward loop to speed up the convergence
    for i=nx:-1:1,
        for j=ny:-1:1,
            cost=zeros(1,256);
            cost=(intensityarray-corrupted(i,j)).^2/(beta2);            
            if i==1,
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
            elseif i==nx
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            end
            if j==1,
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);
            elseif j==ny
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);                
            end
            if (i~=1)&&(i~=nx)&&(j~=1)&&(j~=ny)
                cost=cost+min((intensityarray-newimage(i+1,j+1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i+1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j+1)).^2/alpha2,threshold);
            end
            
            [minval minind]=min(cost); 
            solutionimage(i,j)=intensityarray(minind);
        end
    end     
    
    totalenergy=sum(sum((solutionimage-corrupted).^2/beta2));
    for i=1:nx
        if i==1,
            totalenergy=totalenergy+sum(min((solutionimage(i+1,:)-solutionimage(i,:)).^2/alpha2,threshold));
        elseif i==nx
            totalenergy=totalenergy+sum(min((solutionimage(i,:)-solutionimage(i-1,:)).^2/alpha2,threshold));
        else
            totalenergy=totalenergy+sum(min((solutionimage(i+1,:)-solutionimage(i,:)).^2/alpha2,threshold));
            totalenergy=totalenergy+sum(min((solutionimage(i,:)-solutionimage(i-1,:)).^2/alpha2,threshold));
        end
    end   
    totalenergy 
    
    
    imshow(uint8(newimage))
    title(['Iter No: ', num2str(iter)])
    pause(0.05)
end



